SystemOrganization addCategory: #'SqueakSource-Tests'!

TestResource subclass: #SSMonticelloPackagesResource
	instanceVariableNames: 'monticelloRepository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Tests'!

!SSMonticelloPackagesResource class methodsFor: 'accessing' stamp: 'dkh 05/18/2011 08:03'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!SSMonticelloPackagesResource class methodsFor: 'accessing' stamp: 'dkh 05/18/2011 08:03'!
project

	^self new project! !

!SSMonticelloPackagesResource class methodsFor: 'accessing' stamp: 'dkh 05/18/2011 08:03'!
projectAttributes

	^#()! !

!SSMonticelloPackagesResource methodsFor: 'accessing' stamp: 'dkh 05/18/2011 08:03'!
monticelloRepository
	^ monticelloRepository! !

!SSMonticelloPackagesResource methodsFor: 'accessing' stamp: 'dkh 05/18/2011 08:04'!
project
	"self reset"

	| constructor project |
	"Construct Metacello project"
	project := MetacelloMCProject new.
	"Allow for customization of #projectAttributes"
	project projectAttributes: (Smalltalk at: #SSMonticelloPackagesResource) projectAttributes.
	MetacelloVersionConstructor on: self project: project.
	project loader: 
		((project loaderClass new)
			shouldDisablePackageCache: true;
			yourself).
	project loadType: #linear.
	^project! !

!SSMonticelloPackagesResource methodsFor: 'running' stamp: 'dkh 05/18/2011 08:28'!
setUp
	"self reset"

	| ancestor |
	super setUp.
	self setUpMonticelloRepository.
	ancestor := self
		setUpPackageClassDefs: { #Object. #SSFooTestA. #(). #(). #(). }
		methodDefs: {
			#Object. #fooTestA. 'fooTestA ^1'.
			#SSFooTestA. #fooTestA. 'fooTestA ^1'.
			#SSFooTestA. #fooTestB. 'fooTestA ^1'.
			}
		named: 'SSFooCommandTestA-dkh.1'
		ancestors: #().
	self
		setUpPackageClassDefs: { 
			#Object. #SSFooTestA. #('iv'). #(). #(). 
			#Object. #SSFooTestB. #(). #(). #(). 
		}
		methodDefs: {
			#Object. #fooTestA. 'fooTestA ^2'.
			#SSFooTestA. #fooTestA. 'fooTestA ^1'.
			#SSFooTestB. #fooTestB. 'fooTestA ^1'.
			}
		named: 'SSFooCommandTestA-dkh.2'
		ancestors: { ancestor }.! !

!SSMonticelloPackagesResource methodsFor: 'running' stamp: 'dkh 05/18/2011 08:03'!
setUpMonticelloRepository
	"This method builds a fake repository with the version references from #buildReferences."
	"self reset"

	monticelloRepository := MCDictionaryRepository new.! !

!SSMonticelloPackagesResource methodsFor: 'running' stamp: 'dkh 05/18/2011 08:03'!
setUpPackageClassDefs: classDefArray methodDefs: methodDefArray named: packageName ancestors: ancestors
	"self reset"
	
	| definitions superclassName className ivNames cvNames civNames versionInfo methodSelector methodSource basePackageName authorName |
	definitions := OrderedCollection new.
	basePackageName := packageName copyUpToLast: $-.
	authorName := (packageName copyAfterLast: $-) copyUpTo: $..
	1 to: classDefArray size by: 5 do: [:index |
		superclassName := (classDefArray at: index) asSymbol.
		className := (classDefArray at: index + 1) asSymbol.
		ivNames := (classDefArray at: index + 2).
		cvNames := (classDefArray at: index + 3).
		civNames := (classDefArray at: index + 4).
		definitions add: (MCClassDefinition 
			name: className 
			superclassName: superclassName 
			category: basePackageName 
			instVarNames: ivNames 
			classVarNames: cvNames
			poolDictionaryNames: #()
			classInstVarNames: civNames
			comment: '').
		(cvNames, ivNames) do: [:ivName | 
			definitions addAll: {
					MCMethodDefinition 
						className: className asString
						selector: ivName asSymbol
						category: 'cat'
						timeStamp: ''
						source: ivName, ' ^', ivName.
					MCMethodDefinition 
						className: className asString
						selector: (ivName, ':') asSymbol
						category: 'cat'
						timeStamp: ''
						source: ivName, ':  anObject ', ivName, ' := anObject'.
				} ].
		civNames do: [:ivName | 
			definitions addAll: {
					MCMethodDefinition 
						className: className asString
						selector: ivName asSymbol
						category: 'cat'
						timeStamp: ''
						source: ivName, ' ^self class ', ivName.
					MCMethodDefinition 
						className: className asString
						selector: (ivName, ':') asSymbol
						category: 'cat'
						timeStamp: ''
						source: ivName, ':  anObject self class ', ivName, ': anObject'.
					MCMethodDefinition 
						className: className asString
						classIsMeta: true
						selector: ivName asSymbol
						category: 'cat'
						timeStamp: ''
						source: ivName, ' ^', ivName.
					MCMethodDefinition 
						className: className asString
						classIsMeta: true
						selector: (ivName, ':') asSymbol
						category: 'cat'
						timeStamp: ''
						source: ivName, ':  anObject ', ivName, ' := anObject'.
				} ].
		ivNames do: [:ivName|
			definitions add: 
					(MCMethodDefinition 
						className: className asString
						selector: #sampleValue
						category: 'cat'
						timeStamp: ''
						source: 'sampleValue ^#''', ivName, '''') ].
		].
	1 to: methodDefArray size by: 3 do: [:index |
		className := (methodDefArray at: index) asSymbol.
		methodSelector := (methodDefArray at: index + 1) asSymbol.
		methodSource := (methodDefArray at: index + 2).
		definitions add: 
					(MCMethodDefinition 
						className: className asString
						selector: methodSelector
						category: ('*', packageName) asString
						timeStamp: ''
						source: methodSource).
		].
	monticelloRepository basicStoreVersion: (MCVersion new
		setPackage:  (MCPackage new name: basePackageName)
		info: (versionInfo := MCVersionInfo
				name: packageName
				id: UUID new
				message: 'This is a mock version'
				date: Date today
				time: Time now
				author: authorName
				ancestors: ancestors)
		snapshot: (MCSnapshot fromDefinitions: definitions asArray)
		dependencies: #()).
	^versionInfo! !

!SSMonticelloPackagesResource methodsFor: 'running' stamp: 'dkh 05/18/2011 08:03'!
setUpPackageClassDefs: classDefArray named: pName ancestors: ancestors
	"self reset"
	
	^self setUpPackageClassDefs: classDefArray methodDefs: #() named: pName ancestors: ancestors! !

TestCase subclass: #SSTestAccessRights
	instanceVariableNames: 'creator admin developer guest other anonymous project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Tests'!

!SSTestAccessRights methodsFor: 'setUp' stamp: 'topa 5/18/2011 10:37'!
setUp
	creator := SSMember initials: 'cr'.
	admin := SSMember initials: 'ad'.
	developer := SSMember initials: 'de'.
	guest := SSMember initials: 'gu'.
	other := SSMember initials: 'ot'.
	anonymous := SSMember anonymousMember.
	
	project := SSProject creator: creator.
	project accessPolicy addAdmin: admin.
	project accessPolicy addDeveloper: developer.
	project accessPolicy addGuest: guest.! !

!SSTestAccessRights methodsFor: 'running' stamp: 'topa 5/18/2011 10:38'!
testAccess
	"Test default global read all access right"
	"self run: #testAccess"
	
	self assert: (project isMember: creator allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: creator allowedTo: SSAccessPolicy write).
	self assert: (project isMember: creator allowedTo: SSAccessPolicy read).
	
	self assert: (project isMember: admin allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: admin allowedTo: SSAccessPolicy write).
	self assert: (project isMember: admin allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: developer allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: developer allowedTo: SSAccessPolicy write).
	self assert: (project isMember: developer allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: guest allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: guest allowedTo: SSAccessPolicy write).
	self assert: (project isMember: guest allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: other allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: other allowedTo: SSAccessPolicy write).
	self assert: (project isMember: other allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: anonymous allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: anonymous allowedTo: SSAccessPolicy write).
	self assert: (project isMember: anonymous allowedTo: SSAccessPolicy read).
	
	self 
		should: [ project isMember: admin allowedTo: #zork ] 
		raise: Error.
	
	project admins: (project admins copyWithout: creator).
	self deny: (project isMember: creator allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: creator allowedTo: SSAccessPolicy write).
	self assert: (project isMember: creator allowedTo: SSAccessPolicy read).! !

!SSTestAccessRights methodsFor: 'running' stamp: 'topa 5/18/2011 10:38'!
testAccessNoAccess
	"self run: #testAccessNoAccess"
	
	project globalRight: SSAccessPolicy allowNothing.
	
	self assert: (project isMember: creator allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: creator allowedTo: SSAccessPolicy write).
	self assert: (project isMember: creator allowedTo: SSAccessPolicy read).
	
	self assert: (project isMember: admin allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: admin allowedTo: SSAccessPolicy write).
	self assert: (project isMember: admin allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: developer allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: developer allowedTo: SSAccessPolicy write).
	self assert: (project isMember: developer allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: guest allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: guest allowedTo: SSAccessPolicy write).
	self assert: (project isMember: guest allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: other allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: other allowedTo: SSAccessPolicy write).
	self deny: (project isMember: other allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: anonymous allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: anonymous allowedTo: SSAccessPolicy write).
	self deny: (project isMember: anonymous allowedTo: SSAccessPolicy read).
	
	self 
		should: [ project isMember: admin allowedTo: #zork ] 
		raise: Error.
	
	project admins: (project admins copyWithout: creator).
	self deny: (project isMember: creator allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: creator allowedTo: SSAccessPolicy write).
	self deny: (project isMember: creator allowedTo: SSAccessPolicy read).! !

!SSTestAccessRights methodsFor: 'running' stamp: 'topa 5/18/2011 10:38'!
testGlobalAccess
	"self run: #testGlobalAccess"
	
	project globalRight: SSAccessPolicy allowAllRead.
	
	self deny: (project isMember: other allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: other allowedTo: SSAccessPolicy write).
	self assert: (project isMember: other allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: anonymous allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: anonymous allowedTo: SSAccessPolicy write).
	self assert: (project isMember: anonymous allowedTo: SSAccessPolicy read).
	
	project globalRight: SSAccessPolicy allowAllWrite.
	
	self deny: (project isMember: other allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: other allowedTo: SSAccessPolicy write).
	self assert: (project isMember: other allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: anonymous allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: anonymous allowedTo: SSAccessPolicy write).
	self assert: (project isMember: anonymous allowedTo: SSAccessPolicy read).! !

!SSTestAccessRights methodsFor: 'running' stamp: 'pmm 10/8/2007 20:27'!
testInitialization
	"self run: #testInitialization"
	
	self deny: project accessPolicy isNil.
	
	self assert: project creator = creator.
	
	self assert: (project admins includesAllOf: (Array with: creator with: admin)).
	self assert: project admins size = 2.
	
	self assert: (project developers includes: developer).
	self assert: project developers size = 1.
	
	self assert: (project guests includes: guest).
	self assert: project guests size = 1.
	
	self assert: project globalRight = SSAccessPolicy allowAllRead! !

!SSTestAccessRights methodsFor: 'running' stamp: 'lr 2/27/2004 19:19'!
testSuperuser
	"self run: #testSuperuser"
	
	| superuser |
	superuser := (SSMember initials: 'su') superuser: true.
	self assert: superuser isSuperUser.
	
	project globalRight: SSAccessPolicy allowAllRead.
	self assert: (project isMember: superuser allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: superuser allowedTo: SSAccessPolicy read).
	self assert: (project isMember: superuser allowedTo: SSAccessPolicy write).! !

TestCase subclass: #SSTestStorage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Tests'!

SSTestStorage subclass: #SSTestDictionaryStorage
	instanceVariableNames: 'storage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Tests'!

!SSTestDictionaryStorage methodsFor: 'accessing' stamp: 'dkh 05/20/2011 11:52'!
storageInstance

	storage ifNil: [ storage := SSDictionaryStorage new ].
	^storage! !

SSTestStorage subclass: #SSTestNestedDictionaryStorage
	instanceVariableNames: 'storage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Tests'!

!SSTestNestedDictionaryStorage methodsFor: 'accessing' stamp: 'dkh 05/18/2011 08:48'!
storageInstance

	storage ifNil: [ storage := SSNestedDictionaryStorage new ].
	^storage! !

!SSTestStorage class methodsFor: 'Testing' stamp: 'topa 5/23/2011 10:30'!
isAbstract
	"Override to true if a TestCase subclass is Abstract and should not have
	TestCase instances built from it"

	^self name = #SSTestStorage! !

!SSTestStorage methodsFor: 'private' stamp: 'topa 5/24/2011 15:16'!
mczDiffyString

	| repo mczVersion1 mczVersion2 diffyVersion stream |
	repo := SSMonticelloPackagesResource current monticelloRepository.
	mczVersion1 := self repo: repo versionNamed: 'SSFooCommandTestA-dkh.1'.
	mczVersion2 := self repo: repo versionNamed: 'SSFooCommandTestA-dkh.2'.
	diffyVersion := mczVersion1 asDiffAgainst: mczVersion2.
	stream := RWBinaryOrTextStream on: String new.
	diffyVersion fileOutOn: stream.
	^stream contents asString! !

!SSTestStorage methodsFor: 'private' stamp: 'topa 5/23/2011 10:53'!
mczString

	| repo mczVersion stream |
	repo := SSMonticelloPackagesResource current monticelloRepository.
	mczVersion := repo versionNamed: 'SSFooCommandTestA-dkh.1'.
	stream := RWBinaryOrTextStream on: String new.
	mczVersion fileOutOn: stream.
	^stream contents asString.! !

!SSTestStorage methodsFor: 'private' stamp: 'topa 5/24/2011 15:18'!
repo: aRepository versionNamed: aString

	"Discriminate Monticello API"
	^ (aRepository respondsTo: #versionNamed:)
		ifTrue: [aRepository versionNamed: aString]
		ifFalse: [aRepository versionFromVersionNamed: aString]! !

!SSTestStorage methodsFor: 'accessing' stamp: 'dkh 05/20/2011 11:51'!
storageInstance

	self subclassResponsibility! !

!SSTestStorage methodsFor: 'tests' stamp: 'dkh 05/18/2011 08:58'!
testDiffySaveLoad

	| mczContents array version project diffyName |
	mczContents := self mczDiffyString.
	array := mczContents asByteArray.
	version := SSVersion 
		array: array 
		author: SSMember anonymousMember.
	project := SSProject creator: SSMember anonymousMember.
	project id: 'TestProject'.
	diffyName := MCDiffyVersion canonicalNameFor: version name.
	self storageInstance
		saveDiff: mczContents 
		named: diffyName
		to: project.
	self assert: mczContents = (self storageInstance loadDiffNamed: diffyName from: project)! !

!SSTestStorage methodsFor: 'tests' stamp: 'dkh 05/18/2011 08:21'!
testSaveLoad

	| mczContents array version project |
	mczContents := self mczString.
	array := mczContents asByteArray.
	version := SSVersion 
		array: array 
		author: SSMember anonymousMember.
	project := SSProject creator: SSMember anonymousMember.
	project id: 'TestProject'.
	self storageInstance 
		saveMonticello: mczContents 
		of: version 
		to: project.
	self assert: mczContents = (self storageInstance loadMonticello: version from: project)! !
